Subject: Re: [PATCH bpf v2 1/3] xdp: check prog type before updating BPF link

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Sat, 08 Jan 2022 21:21:04 +0100

Alexei Starovoitov <[email-masked]> writes:

> On Fri, Jan 7, 2022 at 2:11 PM Toke Høiland-Jørgensen <[email-masked]> wrote:
>>
>> The bpf_xdp_link_update() function didn't check the program type before
>> updating the program, which made it possible to install any program type as
>> an XDP program, which is obviously not good. Syzbot managed to trigger this
>> by swapping in an LWT program on the XDP hook which would crash in a helper
>> call.
>>
>> Fix this by adding a check and bailing out if the types don't match.
>>
>> Fixes: 026a4c28e1db ("bpf, xdp: Implement LINK_UPDATE for BPF XDP link")
>> Reported-by: [email-masked]
>> Acked-by: Andrii Nakryiko <[email-masked]>
>> Signed-off-by: Toke Høiland-Jørgensen <[email-masked]>
>
> Thanks a lot for the quick fix!
> The merge window is about to begin.
> We will land it as soon as possible when bpf tree will be ready
> to accept fixes.

You're welcome! That's fine; FWIW, I believe the patch applies cleanly
to bpf-next as well, if that makes things easier on your end :)

-Toke